Index: NEMO/branches/2019/dev_r10721_KERNEL-02_Storkey_Coward_IMMERSE_first_steps/src/OCE/step.F90
===================================================================
--- NEMO/branches/2019/dev_r10721_KERNEL-02_Storkey_Coward_IMMERSE_first_steps/src/OCE/step.F90	(revision 10802)
+++ NEMO/branches/2019/dev_r10721_KERNEL-02_Storkey_Coward_IMMERSE_first_steps/src/OCE/step.F90	(revision 10806)
@@ -178,6 +178,6 @@
 !!jc: fs simplification
                             
-                         ua(:,:,:) = 0._wp            ! set dynamics trends to zero
-                         va(:,:,:) = 0._wp
+                         uu(:,:,:,Nrhs) = 0._wp            ! set dynamics trends to zero
+                         vv(:,:,:,Nrhs) = 0._wp
 
       IF(  lk_asminc .AND. ln_asmiau .AND. ln_dyninc )   &
@@ -190,5 +190,5 @@
                          CALL dyn_adv       ( kstp, Nm1, Nnn, uu(:,:,:,Nrhs), vv(:,:,:,Nrhs) )  ! advection (vector or flux form)
                          CALL dyn_vor       ( kstp,      Nnn, uu(:,:,:,Nrhs), vv(:,:,:,Nrhs) )  ! vorticity term including Coriolis
-                         CALL dyn_ldf       ( kstp )  ! lateral mixing
+                         CALL dyn_ldf       ( kstp, Nm1, Nnn, uu(:,:,:,Nrhs), vv(:,:,:,Nrhs) )  ! lateral mixing
       IF( ln_zdfosm  )   CALL dyn_osm       ( kstp )  ! OSMOSIS non-local velocity fluxes
                          CALL dyn_hpg       ( kstp )  ! horizontal gradient of Hydrostatic pressure
@@ -233,13 +233,13 @@
       ! Active tracers                              
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-                         tsa(:,:,:,:) = 0._wp         ! set tracer trends to zero
+                         ts(:,:,:,:,Nrhs) = 0._wp         ! set tracer trends to zero
 
       IF(  lk_asminc .AND. ln_asmiau .AND. &
          & ln_trainc )   CALL tra_asm_inc   ( kstp )  ! apply tracer assimilation increment
-                         CALL tra_sbc       ( kstp )  ! surface boundary condition
-      IF( ln_traqsr  )   CALL tra_qsr       ( kstp )  ! penetrative solar radiation qsr
-      IF( ln_trabbc  )   CALL tra_bbc       ( kstp )  ! bottom heat flux
-      IF( ln_trabbl  )   CALL tra_bbl       ( kstp )  ! advective (and/or diffusive) bottom boundary layer scheme
-      IF( ln_tradmp  )   CALL tra_dmp       ( kstp )  ! internal damping trends
+                         CALL tra_sbc       ( kstp, Nnn, ts(:,:,:,:,Nrhs) )  ! surface boundary condition
+      IF( ln_traqsr  )   CALL tra_qsr       ( kstp, Nnn, Nnn_2lev, ts(:,:,:,:,Nrhs) )  ! penetrative solar radiation qsr
+      IF( ln_trabbc  )   CALL tra_bbc       ( kstp, Nnn, ts(:,:,:,:,Nrhs) )  ! bottom heat flux
+      IF( ln_trabbl  )   CALL tra_bbl       ( kstp, Nm1, Nnn, Nnn_2lev, ts(:,:,:,:,Nrhs) )  ! advective (and/or diffusive) bottom boundary layer scheme
+      IF( ln_tradmp  )   CALL tra_dmp       ( kstp, Nm1, Nnn_2lev, ts(:,:,:,:,Nrhs) )  ! internal damping trends
       IF( ln_bdy     )   CALL bdy_tra_dmp   ( kstp )  ! bdy damping trends
 #if defined key_agrif
@@ -247,9 +247,9 @@
                &         CALL Agrif_Sponge_tra        ! tracers sponge
 #endif
-                         CALL tra_adv       ( kstp, Nm1, Nnn, Np1, ts(:,:,:,:,Nrhs) )  ! horizontal & vertical advection
+                         CALL tra_adv       ( kstp, Nm1, Nnn, Np1, Nnn_2lev, ts(:,:,:,:,Nrhs) )  ! horizontal & vertical advection
       IF( ln_zdfosm  )   CALL tra_osm       ( kstp )  ! OSMOSIS non-local tracer fluxes
       IF( lrst_oce .AND. ln_zdfosm ) &
            &             CALL osm_rst( kstp, 'WRITE' )! write OSMOSIS outputs + wn (so must do here) to restarts
-                         CALL tra_ldf       ( kstp )  ! lateral mixing
+                         CALL tra_ldf       ( kstp, Nm1, Nnn, Nnn_2lev, ts(:,:,:,:,Nrhs)  )  ! lateral mixing
 
 !!gm : why CALL to dia_ptr has been moved here??? (use trends info?)
@@ -343,4 +343,7 @@
       vb => vv(:,:,:,Nm1); vn => vv(:,:,:,Nnn); va => vv(:,:,:,Np1)
       wn => ww(:,:,:)
+      hdivn => hdiv(:,:,:)
+      rab_b  => r_ab  (:,:,:,:,Nm1_2lev); rab_n  => r_ab (:,:,:,:,Nnn_2lev)
+      rn2b   => r_n2 (:,:,:,Nm1_2lev)   ; rn2    => r_n2 (:,:,:,Nnn_2lev)
 
       tsb => ts(:,:,:,:,Nm1); tsn => ts(:,:,:,:,Nnn); tsa => ts(:,:,:,:,Np1)
@@ -360,10 +363,4 @@
       gde3w_n => gde3w(:,:,:)
 
-      ht_n => ht(:,:)
-      hu_b => hu(:,:,Nm1); hu_n => hu(:,:,Nnn); hu_a => hu(:,:,Np1)
-      hv_b => hv(:,:,Nm1); hv_n => hv(:,:,Nnn); hv_a => hv(:,:,Np1)
-      r1_hu_b => r1_hu(:,:,Nm1); r1_hu_n => r1_hu(:,:,Nnn); r1_hu_a => r1_hu(:,:,Np1)
-      r1_hv_b => r1_hv(:,:,Nm1); r1_hv_n => r1_hv(:,:,Nnn); r1_hv_a => r1_hv(:,:,Np1)
-
    END SUBROUTINE update_pointers
 
